//
//  ViewController.m
//  iGChart_LegendWithCustomMarkers
//
//  Created by IGUser on 5/15/14.
//  Copyright (c) 2014 MMAcademy. All rights reserved.
//

#import "ViewController.h"

@interface ViewController ()

@end

@implementation ViewController

- (void)viewDidLoad
{
    [super viewDidLoad];
    
    int legendHeight = 20;
    
    CGRect rect = self.view.bounds;
	_firstSource = [[IGBubbleSeriesDataSourceHelper alloc] initWithData:[self generateValues] xPath:@"_xValue" yPath:@"_yValue" andRadiusPath:@"_radius"];
    _secondSource = [[IGBubbleSeriesDataSourceHelper alloc] initWithData:[self generateValues] xPath:@"_xValue" yPath:@"_yValue" andRadiusPath:@"_radius"];
    _thirdSource = [[IGBubbleSeriesDataSourceHelper alloc] initWithData:[self generateValues] xPath:@"_xValue" yPath:@"_yValue" andRadiusPath:@"_radius"];
    
    
    _infraChart = [[IGChartView alloc] initWithFrame:CGRectMake(rect.origin.x, rect.origin.y, rect.size.width, rect.size.height - legendHeight)];
    _infraChart.autoresizingMask = UIViewAutoresizingFlexibleHeight | UIViewAutoresizingFlexibleWidth;
    _infraChart.delegate = self;
    
    IGNumericXAxis *xAxis= [[IGNumericXAxis alloc] initWithKey:@"xAxis"];
    IGNumericYAxis *yAxis= [[IGNumericYAxis alloc] initWithKey:@"yAxis"];
    
    [_infraChart addAxis:xAxis];
    [_infraChart addAxis:yAxis];
    
    _firstSeries = [[IGBubbleSeries alloc] initWithKey:@"firstSeries"];
    _firstSeries.title = @"First Series";
    _firstSeries.xAxis = xAxis;
    _firstSeries.yAxis = yAxis;
    _firstSeries.dataSource = _firstSource;
    
    _secondSeries = [[IGBubbleSeries alloc] initWithKey:@"secondSeries"];
    _secondSeries.title = @"Second Series";
    _secondSeries.xAxis = xAxis;
    _secondSeries.yAxis = yAxis;
    _secondSeries.dataSource = _secondSource;
    
    _thirdSeries = [[IGBubbleSeries alloc] initWithKey:@"thirdSeries"];
    _thirdSeries.title = @"Third Series";
    _thirdSeries.xAxis = xAxis;
    _thirdSeries.yAxis = yAxis;
    _thirdSeries.dataSource = _thirdSource;
    
    [_infraChart addSeries:_firstSeries];
    [_infraChart addSeries:_secondSeries];
    [_infraChart addSeries:_thirdSeries];
    [self.view addSubview:_infraChart];
    
    CustomLegend *legend = [[CustomLegend alloc]initWithFrame:CGRectMake(20, 20, 200, 100)];
    _infraChart.legend = legend;
    legend.orientation = IGOrientationVertical;
    [self.view addSubview:legend];
    
     
}

-(UIView *)chartView:(IGChartView *)chartView viewForMarkerInSeries:(IGSeries *)series withItem:(NSObject *)item index:(NSInteger)index originalSourceItem:(NSObject *)originalSourceItem displayOptions:(IGMarkerDisplayOptions *)options
{
    IGBubblePoint *point = (IGBubblePoint*)item;
    CGFloat radius = point.radius;
    CGRect frame = CGRectMake(0, 0, radius, radius);
    
    UIView *view = [[UIView alloc]initWithFrame:frame];
    UIColor *color;
    view.backgroundColor = [UIColor clearColor];
    switch ([_infraChart.series indexOfObject:series]) {
        case 0:
            color = [UIColor redColor];
            break;
        case 1:
            color = [UIColor orangeColor];
            break;
        case 2:
            color = [UIColor blueColor];
            break;
            
        default:
            break;
    }

    
    UILabel *label = [[UILabel alloc]initWithFrame:frame];
    label.userInteractionEnabled = YES;
    label.layer.cornerRadius = radius/2;
    label.layer.backgroundColor = color.CGColor;
    label.text = [NSString stringWithFormat:@"%1.f",radius];
    label.textColor = [UIColor whiteColor];
    label.textAlignment = NSTextAlignmentCenter;
    [view addSubview:label];
    
    UITapGestureRecognizer *tapGesture = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(click)];
    [label addGestureRecognizer:tapGesture];
    
    options.displayAsImage = YES;

    return view;
}

-(void)click
{
    
}

-(NSMutableArray *)generateValues
{
    NSMutableArray *values = [[NSMutableArray alloc] init];
    
    for(int i =0 ;i <10; i++)
    {
        DataModel *value = [[DataModel alloc] initWithXValue:arc4random() % 100 yValue:arc4random() % 100 andRadius:arc4random() % 20 +40];
        [values addObject:value];
        
    }
    return values;
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

@end
@implementation DataModel
@synthesize _xValue, _yValue, _radius;
-(DataModel *)initWithXValue: (double)xValue yValue:(double)yValue andRadius: (double)radius;
{
    self = [super init];
    if (self)
    {
        self._xValue = xValue;
        self._yValue = yValue;
        self._radius = radius;
    }
    return self;
}
@end
